import { jsxs as t, jsx as e } from "react/jsx-runtime";

import { useState as o, useLayoutEffect as r, useMemo as n, useCallback as i, useEffect as s, useRef as l } from "react";

import { VirtualScrollerEvent as c, _ALL_EVENTS as a, VirtualScroller as h } from "@af-utils/virtual-core";

import { useSyncExternalStore as f } from "use-sync-external-store/shim";

/**
 * @public
 * Map current visible items
 * @param model - {@link @af-utils/virtual-core#VirtualScroller} instance
 * @param cb - callback, returning ONLY ONE react element
 */ const d = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to; n > r; r++) o.push(e(r));
    return o;
}, u = (t, e) => {
    const o = [];
    for (let r = t.from, n = t.to, i = t.getOffset(r); n > r; r++, i += t.getSize(r)) o.push(e(r, i));
    return o;
}, m = {
    position: "relative",
    overflow: "hidden",
    contain: "strict",
    // otherwise may go above sticky header
    zIndex: -1
}, p = {
    ...m,
    height: "100%"
}, S = {
    ...m,
    width: "100%"
}, v = {
    position: "absolute",
    contain: "strict",
    overflow: "hidden",
    top: 0,
    left: 0
}, g = {
    ...v,
    display: "flex",
    height: "100%"
}, y = {
    ...v,
    display: "block",
    width: "100%"
}, x = t => {
    const [e, n] = o(null), [i, s] = o(null);
    return r((() => {
        if (e && i) {
            const o = t.on((() => {
                e.style[t.horizontal ? "width" : "height"] = t.scrollSize + "px";
            }), [ c.SCROLL_SIZE ]), r = t.on((() => {
                const e = t.getOffset(t.from), o = t.getOffset(t.to);
                i.style.transform = `translate${t.horizontal ? "X" : "Y"}(${e}px)`, i.style[t.horizontal ? "width" : "height"] = o - e + "px";
            }), [ c.RANGE, c.SIZES ]);
            return Object.assign(e.style, t.horizontal ? p : S), Object.assign(i.style, t.horizontal ? g : y), 
            () => {
                o(), r();
            };
        }
    }), [ t, e, i ]), [ n, s ];
};

/**
 * @public
 * Map current visible items and provide offset for each item.
 *
 * @remarks
 * Used in scenarios, when each item is absolutely positioned
 *
 * @param model - {@link @af-utils/virtual-core#VirtualScroller} instance
 * @param cb - callback, returning ONLY ONE react element
 */ function z(t) {
    switch (t) {
      case c.RANGE:
        return this.to ** 2 + this.from;

        // szudzik pair
              case c.SCROLL_SIZE:
        return this.scrollSize;

      default:
        return this.sizesHash;
    }
}

/**
 * @public
 * React hook.
 * Rerenders component when one of {@link @af-utils/virtual-core#(VirtualScrollerEvent:variable)} gets emitted.
 * Usually {@link Subscription} is a better alternative
 */ const w = function(t, e) {
    void 0 === e && (e = a);
    const [o, r] = n((() => [ o => t.on(o, e), () => e.map(z, t).join() ]), [ t, e ]);
    f(o, r, r);
}, E = t => (w(t.model, t.events), t.children()), I = o => {
    let {model: r, children: n, itemData: s, component: l, header: a = null, footer: h = null, getKey: f = (t => t), tabIndex: u = -1, style: m, ...p} = o;
    const S = l || "div", [v, g] = x(r);
    return t(S, {
        ...p,
        style: {
            overflow: "auto",
            contain: "strict",
            ...m
        },
        ref: i((t => r.setScroller(t)), [ r ]),
        tabIndex: u,
        children: [ a, e("div", {
            ref: v,
            children: e("div", {
                ref: g,
                children: e(E, {
                    model: r,
                    events: [ c.RANGE ],
                    children: () => d(r, (t => e(n, {
                        model: r,
                        i: t,
                        data: s
                    }, f(t, s))))
                })
            })
        }), h ]
    });
}, O = process.env.__IS_SERVER__ ? s : r, R = (t, e) => O((() => (t.setScroller(e), 
() => t.setScroller(null))), [ t, e ])
/**
 * @public
 * React hook.
 * Allows to subscribe to {@link @af-utils/virtual-core#(VirtualScrollerEvent:variable)} without unnecessary rerenders.
 *
 * @remarks
 * For example can be used in load-on-demand.
 *
 * @param model - {@link @af-utils/virtual-core#VirtualScroller} instance
 * @param events - array of {@link @af-utils/virtual-core#VirtualScrollerEvent} to subscribe
 * @param callBack - callback to be called
 */ , _ = (t, e, o) => s((() => {
    if (o) return o(), t.on(o, e);
}), [ t, o, e ])
/**
 * @public
 * React hook.
 * Creates and stores one {@link @af-utils/virtual-core#VirtualScroller} instance.
 * It does not get recreated during component lifecycle.
 * Normally {@link useVirtual} should be used.
 * @param params - {@link @af-utils/virtual-core#VirtualScrollerInitialParams}
 * @returns same {@link @af-utils/virtual-core#VirtualScroller} instance
 */ , b = t => l().current ||= new h(t)
/**
 * @public
 * React hook.
 * Calls {@link useVirtualModel} and synchronizes it with props
 * @param params - {@link @af-utils/virtual-core#VirtualScrollerInitialParams}
 * @returns same {@link @af-utils/virtual-core#VirtualScroller} instance
 */ , j = t => {
    const e = b(t);
    return O((() => e.set(t))), e;
};

/**
 * @public
 * React component.
 * {@link SubscriptionProps}.
 * Rerenders only on certain {@link @af-utils/virtual-core#(VirtualScrollerEvent:variable)}.
 * Allows to optimize performance.
 */ export { I as List, E as Subscription, d as mapVisibleRange, u as mapVisibleRangeWithOffset, w as useComponentSubscription, R as useScroller, _ as useSubscription, x as useSyncedStyles, j as useVirtual, b as useVirtualModel };
//# sourceMappingURL=index.js.map
